Friend Class CtlText

    Delegate Sub SetTextCallback(ByVal pNewFile As ClsFichier)

    Private WithEvents mAudio As ClsAudio = Nothing
    Private mActRead As ClsFichier = Nothing
    Private mModifFic As ClsFichier = Nothing

    Public Event PauseMusic()
    Public Event NextTitle()

    Public Property Audio() As ClsAudio
        Get
            Return mAudio
        End Get
        Set(ByVal value As ClsAudio)
            mAudio = value
            RefreshValues()
        End Set
    End Property

    Private Property ActRead() As ClsFichier
        Get
            Return mActRead
        End Get
        Set(ByVal value As ClsFichier)
            mActRead = value
            RefreshValues()
        End Set
    End Property

    Private Sub RefreshValues()
        If mModifFic Is Nothing Then
            If mActRead IsNot Nothing Then
                TxtText.Text = mActRead.Texte
                ControleEndLine()
                TxtText.ReadOnly = True
                TxtText.BackColor = System.Drawing.SystemColors.Window
                CmdModif.Enabled = True
                CmdModif.Text = "&Modifier"
                CmdSave.Enabled = False
                LblAct.Text = ActRead.FileTitle
            Else
                TxtText.Text = ""
                TxtText.ReadOnly = True
                TxtText.BackColor = System.Drawing.SystemColors.Window
                CmdModif.Enabled = False
                CmdSave.Enabled = False
                LblAct.Text = "Aucun fichier actuellement charg"
            End If
        ElseIf mModifFic IsNot mActRead Then
            CmdModif.Text = "&Charger le titre actuel"
        End If
    End Sub

    Private Sub mAudio_NewFile(ByVal pNewFile As ClsFichier) Handles mAudio.NewFile
        If Me.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf mAudio_NewFile)
            Me.Invoke(d, New Object() {pNewFile})
        Else
            ActRead = pNewFile
        End If
    End Sub

    Private Sub CtlText_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        RefreshValues()
        Timer1.Enabled = True
    End Sub

    Private Sub CmdModif_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdModif.Click
        If mModifFic Is Nothing Then
            mModifFic = mActRead
            TxtText.ReadOnly = False
            CmdSave.Enabled = True
            CmdModif.Text = "&Annuler l'dition"
        ElseIf mActRead Is mModifFic Then
            If TxtText.Text = mModifFic.Texte Then
                mModifFic = Nothing
                RefreshValues()
            Else
                TxtText.Text = mModifFic.Texte
                CmdModif.Text = "&Annuler l'dition"
                ControleEndLine()
            End If
        Else
            mModifFic = Nothing
            RefreshValues()
        End If
    End Sub

    Private Sub ControleEndLine()
        Dim lText As String = TxtText.Text
        If lText.IndexOf(Chr(10)) <> -1 Xor lText.IndexOf(Chr(13)) <> -1 Then
            Dim ltText As String() = lText.Split(Chr(10))
            If ltText.Length = 1 Then
                ltText = lText.Split(Chr(13))
            End If
            lText = String.Join(vbCrLf, ltText)
            TxtText.Text = lText
        End If
    End Sub

    Private Sub Ctl_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TxtText.KeyDown, CmdModif.KeyDown, CmdSave.KeyDown
        If Keys.Pause = e.KeyCode Or (e.Control And e.KeyCode = Keys.P) Then
            RaiseEvent PauseMusic()
        ElseIf (e.Control And e.KeyCode = Keys.S) Then
            If CmdSave.Enabled = True Then CmdSave_Click(Nothing, Nothing)
        ElseIf e.KeyCode = Keys.Escape Then
            If CmdModif.Enabled = True Then CmdModif_Click(Nothing, Nothing)
        ElseIf (e.Control And e.KeyCode = Keys.N) Then
            RaiseEvent NextTitle()
        End If
    End Sub

    Private Sub TxtText_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtText.TextChanged
        If mModifFic IsNot Nothing And mModifFic Is mActRead Then
            CmdModif.Text = "&Recharger"
        End If
    End Sub

    Private Sub CmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSave.Click
        ControleEndLine()
        mModifFic.Texte = TxtText.Text
        CmdModif.Text = "&Annuler l'dition"
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Try
            If CmdSave.Enabled = False And TxtText.Text.Length > 0 Then
                Dim lInt As Integer = CInt(1.01 * TxtText.Text.Length * mAudio.TimeElapsed / mAudio.TimeTotal)
                If lInt <= TxtText.Text.Length Then
                    TxtText.SelectionStart = lInt
                Else
                    TxtText.SelectionStart = TxtText.Text.Length
                End If
                TxtText.SelectionLength = CInt(TxtText.Text.Length * 0.25 / mAudio.TimeTotal) + 1
                TxtText.ScrollToCaret()
            End If
        Catch ex As Exception
        End Try
    End Sub
End Class
